package com.sun.jmx.snmp.agent;

import java.util.Vector;
import com.sun.jmx.snmp.SnmpVarBind;
import com.sun.jmx.snmp.SnmpStatusException;
import java.io.Serializable;

public abstract class SnmpMibNode implements Serializable
{
    protected int[] varList;
    
    public SnmpMibNode() {
    }
    
    public long getNextVarId(long n, Object o) throws SnmpStatusException {
        return (long)getNextIdentifier(this.varList, n);
    }
    
    public long getNextVarId(long nextVarId, Object o, int n) throws SnmpStatusException {
        do {
            nextVarId = this.getNextVarId(nextVarId, o);
        } while (this.skipVariable(nextVarId, o, n));
        return nextVarId;
    }
    
    protected boolean skipVariable(long n, Object o, int n2) {
        return false;
    }
    
    void findHandlingNode(SnmpVarBind snmpVarBind, long[] array, int n, SnmpRequestTree snmpRequestTree) throws SnmpStatusException {
        throw new SnmpStatusException(225);
    }
    
    long[] findNextHandlingNode(SnmpVarBind snmpVarBind, long[] array, int n, int n2, SnmpRequestTree snmpRequestTree, AcmChecker acmChecker) throws SnmpStatusException {
        throw new SnmpStatusException(225);
    }
    
    public abstract void get(SnmpMibSubRequest p0, int p1) throws SnmpStatusException;
    
    public abstract void set(SnmpMibSubRequest p0, int p1) throws SnmpStatusException;
    
    public abstract void check(SnmpMibSubRequest p0, int p1) throws SnmpStatusException;
    
    public static void sort(int[] array) {
        QuickSort(array, 0, array.length - 1);
    }
    
    public void getRootOid(Vector<Integer> vector) {
    }
    
    static void QuickSort(int[] array, int i, int n) {
        if (n > i) {
            int n2 = array[(i + n) / 2];
            while (i <= n) {
                while (i < n && array[i] < n2) {
                    ++i;
                }
                while (n > i && array[n] > n2) {
                    --n;
                }
                if (i > n) {
                    continue;
                }
                swap(array, i, n);
                ++i;
                --n;
            }
            if (i < n) {
                QuickSort(array, i, n);
            }
            if (i < n) {
                QuickSort(array, i, n);
            }
        }
    }
    
    protected static final int getNextIdentifier(int[] array, long n) throws SnmpStatusException {
        int n2 = (int)n;
        if (array == null) {
            throw new SnmpStatusException(225);
        }
        int i = 0;
        int length = array.length;
        int n3 = i + (length - i) / 2;
        if (length < 1) {
            throw new SnmpStatusException(225);
        }
        if (array[length - 1] <= n2) {
            throw new SnmpStatusException(225);
        }
        while (i <= length) {
            int n4 = array[n3];
            if (n2 == n4) {
                ++n3;
                return array[n3];
            }
            if (n4 < n2) {
                i = n3 + 1;
            }
            else {
                length = n3 - 1;
            }
            n3 = i + (length - i) / 2;
        }
        return array[n3];
    }
    
    private static final void swap(int[] array, int n, int n2) {
        int n3 = array[n];
        array[n] = array[n2];
        array[n2] = n3;
    }
}
